var JobReader = {
    n: 0,
    x: 0,
    pretime: 0,
    isIOS: false,
    padding: 20,
    getDeviceWidth: function () {
        //iOS 9.2 window.innerWidth 值不是设备宽bug
        if (/os 9/ig.test(navigator.userAgent) && /safari/ig.test(navigator.userAgent)) {
            return window.screen.availWidth
        } else {
            return window.innerWidth
        }
    },
    //localStorage.chapterNow="1";//记录章节和阅读位置    add by zhangxingning@zhangyue.com
    hidefont: function () {
        var oAction = document.getElementById('action');
        oAction.style.display = 'none';
    },
    refurbish: function (e) {
        var oBox = document.querySelector('.read_page');
        var oCon = oBox.querySelector('.read_page_con');
        var columnWidth = JobReader.getDeviceWidth();
        oBox.style.WebkitColumnWidth = columnWidth + 'px';
        var clientHeight = document.documentElement.clientHeight - JobReader.padding;
        var pages = Math.ceil(oCon.offsetHeight / (clientHeight));//此处准确性待定
        //bug--部分机型浏览器（Chrome），column父级无宽渲染错误
        oBox.style.WebkitTransform = 'translateX(0px)';
        var c = document.querySelector('.read_page_wrap');
        $(".page span").html('1/' + pages);
        JobReader.n = 0;
        this.x = 0;
        console.log(JobReader.n);
    },
    //事件代理
	on: function() {
		$(document).on.apply($(document), arguments);
    },
	off: function() {
		$(document).off.apply($(document), arguments);
	},
	trigger: function() {
		$(document).trigger.apply($(document), arguments);
	},
    //页码跳转
    pageto: function (index) {
        /*if(this.isIOS){
            var padding = 160;
        }else{
            var padding = 20;
        }*/
        setTimeout(function () {
            console.log(JobReader.padding);
            var columnWidth = JobReader.getDeviceWidth();
            var oBox = document.querySelector('.read_page');
            var oCon = oBox.querySelector('.read_page_con');
            var position = -(index - 1) * columnWidth;
            var clientHeight = document.documentElement.clientHeight - JobReader.padding;
            var pages = Math.ceil(oCon.offsetHeight / (clientHeight));//此处准确性待定
            console.log(oCon.offsetHeight,clientHeight);
            oBox.style.WebkitTransform = 'translateX(' + position + 'px)';
            $(".page span").html(index + '/' + pages);
            JobReader.n = index - 1;
        },200);
    },
    //页码跳转至最后一页
    pageend: function () {
        /*if(this.isIOS){
            var padding = 160;
        }else{
            var padding = 20;
        }*/
        console.log(JobReader.padding);
        setTimeout(function () {
            var columnWidth = JobReader.getDeviceWidth();
            var oBox = document.querySelector('.read_page');
            var oCon = oBox.querySelector('.read_page_con');
            var clientHeight = document.documentElement.clientHeight - JobReader.padding;
            var pages = Math.ceil(oCon.offsetHeight / (clientHeight));//此处准确性待定
            var position = -(pages - 1) * columnWidth;
            oBox.style.WebkitTransform = 'translateX(' + position + 'px)';
            $(".page span").html(pages + '/' + pages);
            JobReader.n = pages - 1;
            // var localbook = window.localStorage['book'];
            // var arr = JSON.parse(localbook);
            // arr[bookid] = chapter + ',' + pages;
            // window.localStorage['book'] = JSON.stringify(arr);
        },200);
    },
    //初始化
    init_reader: function (bookid, chapter, page ,is_init) {
        var fontArr = [
            [24, 14],
            [27, 16],
            [30, 18],
            [33, 20],
            [37, 22]
        ]
        var read_page = document.getElementById('read_page_con');
        var oAction = document.getElementById('action');
        var oList = document.getElementById('list');
        var oFontBig = document.querySelector('.reader-big');
        //减小
        var oFontSmall = document.querySelector('.reader-little')
        var oChapter = document.getElementById('chapter')
        var oJump = document.getElementById('jump');
        var oReader = document.querySelector('.reader-function')
        var c = document.querySelector('.read_page_wrap');
        var oBox = document.querySelector('.read_page');
        var oBackground = document.getElementById('background');
        var oHead = document.querySelector('page_tit');
        var oCon = oBox.querySelector('.read_page_con');
        var x = 0;
        JobReader.n = page - 1;
        if (localStorage.fontSize) {
            oCon.style.fontSize = localStorage.fontSize;
            oCon.style.lineHeight = localStorage.lineHeight;
        };
        /*if(this.isIOS){
            var padding = 160;
        }else{
            var padding = 20;
        }*/
        console.log(JobReader.padding);
        var columnWidth = JobReader.getDeviceWidth();
        oBox.style.WebkitColumnWidth = columnWidth + 'px';
        var clientHeight = document.documentElement.clientHeight - JobReader.padding;
        var pages = Math.ceil(oCon.offsetHeight / (clientHeight));//此处准确性待定
        //bug--部分机型浏览器（Chrome），column父级无宽渲染错误
        oBox.style.height = clientHeight + 'px';
        oBox.style.WebkitTransform = 'translateX(0px)';
        var c = document.querySelector('.reader_content');

        $(".page span").html('1/' + pages);
        oFontBig.addEventListener('click', function () {
            var fontNow = getComputedStyle(oCon, false)['fontSize'];
            for (var i = 0; i < fontArr.length; i++) {
                if (fontArr[i][1] == parseInt(fontNow)) {
                    if (i == fontArr.length - 1) return;
                    oCon.style.fontSize = fontArr[i + 1][1] + 'px';
                    oCon.style.lineHeight = fontArr[i + 1][0] + 'px';
                    localStorage.fontSize = fontArr[i + 1][1] + 'px';
                    localStorage.lineHeight = fontArr[i + 1][0] + 'px';
                };
            };

            n = Math.ceil(oCon.offsetHeight / (document.documentElement.clientHeight - JobReader.padding)) * JobReader.n / pages; //当前总页数*转屏前的第n页/转屏前的总页数
            JobReader.n = Math.floor(n); //当前页，向下取整
            pages = Math.ceil(oCon.offsetHeight / (clientHeight));
            console.log(oCon.offsetHeight, clientHeight);
            x = -JobReader.n * columnWidth;
            var columnWidth = JobReader.getDeviceWidth();
            oBox.style.WebkitTransition = 'none';
            oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
        }, false);

        oFontSmall.addEventListener('click', function () {
            console.log('click');
            var fontNow = getComputedStyle(oCon, false)['fontSize'];
            for (var i = 0; i < fontArr.length; i++) {
                if (fontArr[i][1] == parseInt(fontNow)) {
                    if (i == 0) return;
                    oCon.style.fontSize = fontArr[i - 1][1] + 'px';
                    oCon.style.lineHeight = fontArr[i - 1][0] + 'px';
                    localStorage.fontSize = fontArr[i - 1][1] + 'px';
                    localStorage.lineHeight = fontArr[i - 1][0] + 'px';
                };
            };
            n = Math.ceil(oCon.offsetHeight / (document.documentElement.clientHeight - JobReader.padding)) * JobReader.n / pages; //当前总页数*转屏前的第n页/转屏前的总页数
            JobReader.n = Math.floor(n); //当前页，向下取整
            pages = Math.ceil(oCon.offsetHeight / (clientHeight));
            console.log(oCon.offsetHeight, clientHeight);
            x = -JobReader.n * columnWidth;
            oBox.style.WebkitTransition = 'none';
            oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
        }, false)
        var disX = 0,
            startX = 0,
            startY = 0;
            endX = 0;
        c.addEventListener('touchstart', function (ev) {
            console.log('start');
            var timestamp = (new Date()).getTime();
            //屏蔽双击事件
            if(timestamp - this.pretime < 200){
                c.removeEventListener('touchend', fnEnd, false);
                return;
            }
            this.pretime = timestamp;
            oBox.style.WebkitTransition = 'none';
            disX = ev.targetTouches[0].pageX - x;
            startX = ev.targetTouches[0].pageX;
            startY = ev.targetTouches[0].pageY;
            
            c.addEventListener('touchmove', fnMove, false);
            c.addEventListener('touchend', fnEnd, false);

        }, false);

        function fnMove(ev) {
            console.log('fnMove');
            x = ev.targetTouches[0].pageX - disX;
            oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
            endX = ev.targetTouches[0].pageX;
            ev.preventDefault();
        }
        function fnEnd() {
            console.log('end');
            pages = Math.ceil(oCon.offsetHeight / (clientHeight));
            //console.log(JobReader.n);
            //console.log(endX);
            //console.log('startX:'+startX+'==startY:'+startY+'endX:'+endX+'==columnWidth:'+columnWidth+'==clientHeight:'+clientHeight);
            //if (startX > columnWidth * 2 / 3 || startY > clientHeight * 2 / 3 && startX > columnWidth / 3) {
            if(startX > columnWidth * 2 / 5 && startX < columnWidth * 3 / 5 && startY > clientHeight * 2/ 5 && startY < clientHeight * 3 / 5){
                x = -JobReader.n * columnWidth;
                oBox.style.WebkitTransition = '.2s all ease';
                oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
                if (oAction.style.display == 'block') {

                    oAction.style.display = 'none';
                } else {
                    oAction.style.display = 'block';

                }
            }else if(((startX-endX)>0 && endX!=0) || ( endX==0 && startX > columnWidth /2)){
                console.log('startX:'+startX+'endX:'+endX);
                console.log(columnWidth);
                //电子书当前章节最后一页内容后翻时
                if ((JobReader.n + 1) == pages) {
                    JobReader.trigger('NextMenu');
                    clientHeight = document.documentElement.clientHeight - JobReader.padding;
                    pages = Math.ceil(oCon.offsetHeight / (clientHeight));
                    //最后一页鼠标拖拽出现空白页问题
                    var lastwindth = JobReader.n * columnWidth;
                    oBox.style.WebkitTransform = 'translateX(-' + lastwindth + 'px)';
                    return;
                };
                JobReader.n++;
                x = -JobReader.n * columnWidth;
                oBox.style.WebkitTransition = '.2s all ease';
                oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
                oAction.style.display = 'none';
                endX = 0;
            //} else if (startX < columnWidth / 3 || startY < clientHeight / 3 && startX < columnWidth * 2 / 3) {
            } else if (((startX-endX)<0 && endX!=0) || ( endX==0 && startX < columnWidth /2)) {
                //console.log('222');
                console.log('startX:'+startX+'endX:'+endX);
                console.log(columnWidth);
                //电子书当前章节第一页内容继续前翻
                if (JobReader.n == 0) {
                    JobReader.trigger('PreMenu');
                    oBox.style.WebkitTransform = 'translateX(-0px)';
                    return;
                };
                JobReader.n--;
                if (JobReader.n < 0) {
                    JobReader.n = 0
                };
                x = -JobReader.n * columnWidth;
                oBox.style.WebkitTransition = '.2s all ease';
                oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
                oAction.style.display = 'none';
                endX = 0;
            } 
            // else {
            //     console.log('333');
            //     x = -JobReader.n * columnWidth;
            //     oBox.style.WebkitTransition = '.2s all ease';
            //     oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
            //     if (oAction.style.display == 'block') {

            //         oAction.style.display = 'none';
            //     } else {
            //         oAction.style.display = 'block';

            //     }
            // }
            var lbook = localStorage.book;
            //是否有历史记录
            if (lbook != undefined) {
                var arr = JSON.parse(lbook);
                if (arr[bookid]) {
                    var b_arr = arr[bookid].split(",");
                    arr[bookid] = b_arr[0] + ',' + (JobReader.n + 1);
                    window.localStorage['book'] = JSON.stringify(arr);
                } else {
                    arr[bookid] = chapter + ',' + (JobReader.n + 1);
                    window.localStorage['book'] = JSON.stringify(arr);
                }
            } else {
                var arr = {};
                arr[bookid] = chapter + ',' + (JobReader.n + 1);
                window.localStorage['book'] = JSON.stringify(arr);
            }

            $(".page span").html((JobReader.n + 1) + '/' + pages);
            //c.removeEventListener('touchmove', fnMove, false);
            //c.removeEventListener('touchend', fnEnd, false);
        }


        $(".page span").html((JobReader.n + 1) + '/' + pages);
        // window.addEventListener('orientationchange', function () {
        //     oCon.innerHTML = '';
        //     setTimeout(function () {
        //         oCon.innerHTML = con;
        //         columnWidth = JobReader.getDeviceWidth();
        //         oBox.style.WebkitColumnWidth = columnWidth + 'px';
        //         n = Math.ceil(oCon.offsetHeight / (document.documentElement.clientHeight - 20)) * JobReader.n / pages; //当前总页数*转屏前的第n页/转屏前的总页数
        //         JobReader.n = Math.floor(n); //当前页，向下取整
        //         clientHeight = document.documentElement.clientHeight - 20;
        //         x = -JobReader.n * columnWidth;
        //         oBox.style.height = (clientHeight) + 'px';
        //         oBox.style.WebkitTransition = 'none';
        //         oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
        //         pages = Math.ceil(oCon.offsetHeight / (document.documentElement.clientHeight - 20));
        //         $(".page span").html((JobReader.n + 1) + '/' + pages);
        //     }, 200);
        // });

    }

}